/*
 * Date: Jan 10, 2004
 * Copyright (c) 2004 Matvey Kazakov.
 *
 * $Id$
 */
package ru.ifmo.ips.visualizers.backpack;

/**
 *   .
 * 
 * @author Matvey Kazakov
 */
public class Automaton {

    private Globals g;

    public Automaton(Globals g) {
        this.g = g;
    }

    private void makeAutomationStep() {
        switch (g.state) {
            case 0:     //  
                g.j = 1;
                g.i = 0;
                g.state = 1;
                break;

            case 1: //  0- 
                if (g.j <= g.N) {
                    g.T[0][g.j] = 0;
                    g.j++;
                } else {
                    g.j = 0;
                    g.state = 2;
                }
                break;

            case 2: //  0- 
                if (g.i <= g.K) {
                    g.T[g.i][0] = 1;
                    g.i++;
                } else {
                    g.i = 1;
                    g.state = 3;
                }
                break;

            case 3: //    
                if (g.i <= g.K) {
                    g.j = 1;
                    g.state = 4;
                } else {
                    g.sum = g.N;
                    g.state = 5;
                }
                break;

            case 4: //   
                if (g.j <= g.N && g.j >= g.M[g.i - 1]) {
                    g.T[g.i][g.j] = Math.max(g.T[g.i - 1][g.j], g.T[g.i - 1][g.j - g.M[g.i - 1]]);
                    g.j++;
                } else if (g.j <= g.N && g.j < g.M[g.i - 1]) {
                    g.T[g.i][g.j] = g.T[g.i - 1][g.j];
                    g.j++;
                } else {
                    g.i++;
                    g.state = 3;
                }
                break;

            case 5: //   
                if (g.T[g.K][g.sum] == 1) { //  
                    g.i = g.K;
                    g.state = 6;    //   
                } else {
                    g.result = false;
                    g.state = 9;    //    
                }
                break;

            case 6: //  
                if (g.i > 0) {
                    g.state = 7;
                } else {
                    g.result = true;
                    g.state = 10;
                }
                break;

            case 7: //   
                if (g.T[g.i][g.sum] != g.T[g.i - 1][g.sum]) {
                    g.positions.add(new Integer(g.i - 1));
                    g.sum -= g.M[g.i - 1];
                    g.state = 8;
                } else {
                    g.state = 8;
                }
                break;

            case 8:
                g.i--;
                g.state = 6;
                break;
        }
    }

    /**
     *   .
     */
    public void makeStep() {
        makeAutomationStep();
        while (!isFinished() && (
                g.state == 1 && g.j == g.N + 1
                || g.state == 2 && g.i == g.K + 1
                || g.state == 3
                || g.state == 6
                || g.state == 4 && g.j == g.N + 1
                )) {
            makeAutomationStep();
        }
    }

    /**
     * ,    .
     */
    public boolean isFinished() {
        return g.state == 9 || g.state == 10;
    }


}

/*
 * $Log$
 */