/*
 * Date: Jan 10, 2004
 * Copyright (c) 2004 Matvey Kazakov.
 *
 * $Id$
 */
package ru.ifmo.ips.visualizers.backpack;

import java.util.ArrayList;

/**
 *  .
 * 
 * @author Matvey Kazakov
 */
public class Solution {
    /**
     * @param N     
     * @param M   
     * @return   ,     N,
     *          null   .
     */
    private static Integer[] solve(int N, int[] M) {
        //  
        int i, j;
        //  
        int K = M.length;
        //  T
        int[][] T = new int[K + 1][N + 1];
        //  
        ArrayList positions = new ArrayList();
        //   true,     
        boolean result = false;

        //     T
        for (j = 1; j <= N; j++) {
            T[0][j] = 0;
        }
        for (i = 0; i <= K; i++) {
            T[i][0] = 1;
        }

        //     T
        for (i = 1; i <= K; i++) {
            for (j = 1; j <= N; j++) {
                if (j >= M[i - 1]) {
                    T[i][j] = Math.max(T[i - 1][j], T[i - 1][j - M[i - 1]]);
                } else {
                    T[i][j] = T[i - 1][j];
                }
            }
        }

        //   
        int sum = N;
        if (T[K][sum] == 1) {
            //  
            for (i = K; i >= 1; i--) {
                if (T[i][sum] != T[i - 1][sum]) {
                    positions.add(new Integer(i));
                    sum -= M[i - 1];
                }
            }
            //  
            result = true;
        }

        //   ,   ,   null
        return (Integer[])(result ? positions.toArray(new Integer[0]) : null);
    }

    public static void main(String[] args) {
        int[] M = new int[]{4, 5, 3, 7, 6};
        int N = 16;
        Integer[] result = solve(N, M);
        System.out.print("[");
        for (int i = 0; i < result.length; i++) {
            Integer integer = result[i];
            if (i > 0) {
                System.out.print(", ");
            }
            System.out.print(M[integer.intValue() - 1]);
        }
        System.out.println("]");
    }
}

/*
 * $Log$
 */